#### POSIX Threads for Windows – REFERENCE - Pthreads-w32

Reference Index

Table of Contents

## Name

pthread_once - once-only initialization

## Synopsis

#include <pthread.h>

pthread_once_t once_control = PTHREAD_ONCE_INIT;

int pthread_once(pthread_once_t *once_control, void (*init_routine) (void));

## Description

The purpose of pthread_once is to ensure that a piece of initialization code is executed at most once. The once_control argument points to a static or extern variable statically initialized to PTHREAD_ONCE_INIT.

The first time pthread_once is called with a given once_control argument, it calls init_routine with no argument and changes the value of the once_control variable to record that initialization has been performed. Subsequent calls to pthread_once with the same once_control argument do nothing.

## Cancellation

While pthread_once is not a cancellation point, init_routine can be. The effect on once_control of a cancellation inside the init_routine is to leave it as if pthread_once had not been called by the cancelled thread.

## Return Value

pthread_once returns 0 on success, or an error code on failure.

## Errors

The pthread_once function returns the following error code on error:

EINVAL

The once_control or init_routine parameter is NULL.

## Author

Xavier Leroy <Xavier.Leroy@inria.fr>

Modified by Ross Johnson for use with Pthreads-w32.

Table of Contents

- Name

- Synopsis

- Description

- Cancellation

- Return Value

- Errors

- Author